/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package aisl.model;

import java.util.Collection;
import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.BeforeClass;

/**
 *
 * @author rosmord
 */
public class ForumFacadeTest {

    public ForumFacadeTest() {
    }

    @BeforeClass
    public static void setUpTests() {
        // Erase the old db...
        // Create a new db :
        ForumFacade.clearAndReinit();
    }
    
    /**
     * Test of getInstance method, of class ForumFacade.
     */
    @Test
    public void testGetInstance() {
        System.out.println("getInstance");
        ForumFacade result = ForumFacade.getInstance();
        assertNotNull(result);
    }

    /**
     * Test of createUser method, of class ForumFacade. (todo : test all error
     * conditions).
     */
    @Test
    public void testCreateUser() throws Exception {
        System.out.println("createUser");
        String login = "tmp";
        String password = "pwd";
        Group group = Group.USER;
        ForumFacade instance = ForumFacade.getInstance();
        User result = instance.createUser(login, password, group);
        User fromForum = instance.getUser("tmp");
        assertEquals("tmp", fromForum.getLogin());
        assertEquals("pwd", fromForum.getPassword());
        assertEquals(Group.USER, fromForum.getGroup());
    }

    /**
     * Test of updateUser method, of class ForumFacade.
     */
    @Test
    public void testUpdateUser() throws Exception {
        System.out.println("updateUser");
        ForumFacade instance = ForumFacade.getInstance();
        User toUpdate = instance.getUser("toto");
        instance.updateUser("toto", "truc", Group.ADMIN);
    }

    @Test(expected = ForumException.class)
    public void testUpdateUserFail() throws Exception {
        System.out.println("updateUser (unknown");
        ForumFacade instance = ForumFacade.getInstance();
        instance.updateUser("no such user", "truc", Group.ADMIN);
    }

    /**
     * Test of getUsers method, of class ForumFacade.
     */
    @Test
    public void testGetUsers() {
    }

    /**
     * Test of createMessage method, of class ForumFacade.
     */
    @Test
    public void testCreateMessage() {
        System.out.println("createMessage");
        ForumFacade facade = ForumFacade.getInstance();
        User user = facade.getUser("toto");
        final String TITLE = "nouveau";
        final String TEXT = "texte";
        int id = facade.createMessage(TITLE, TEXT, "toto");
        Message m = facade.getMessage(id);
        assertEquals(TITLE, m.getTitle());
        assertEquals(TEXT, m.getText());
        assertEquals(user, m.getAuthor());
    }

    /**
     * Test of updateMessage method, of class ForumFacade.
     */
    @Test
    public void testUpdateMessage() throws Exception {
        System.out.println("updateMessage");
        final String TITLE = "autre titre";
        final String TEXT = "autre texte";
        ForumFacade facade = ForumFacade.getInstance();
        facade.updateMessage(2, TITLE, TEXT);
        Message msg = facade.getMessage(2);
        assertEquals(facade.getUser("toto"), msg.getAuthor());
        assertEquals(TEXT, msg.getText());
        assertEquals(TITLE, msg.getTitle());
    }

    /**
     * Test of getMessage method, of class ForumFacade.
     */
    @Test
    public void testGetMessage() {
        System.out.println("getMessage");
        // .... f.createMessage("premier message", "ceci est le texte du premier message", admin);
        ForumFacade instance = ForumFacade.getInstance();
        Message result = instance.getMessage(1);
        assertEquals(1, result.getId());
        assertEquals("premier message", result.getTitle());
        assertEquals("ceci est le texte du premier message", result.getText());
        assertEquals(instance.getUser("admin"), result.getAuthor());


    }

    /**
     * Test of getAllMessages method, of class ForumFacade.
     */
    @Test
    public void testGetAllMessages() {
        System.out.println("getAllMessages");
        ForumFacade instance = ForumFacade.getInstance();
        Collection result = instance.getAllMessages();
        assertTrue(result.size() >= 2);
    }

    /**
     * Test of getUser method, of class ForumFacade.
     */
    @Test
    public void testGetUser() {
        System.out.println("getUser");
        // Write it...
    }
}